#include <stdio.h>

double horner1(double a[], int n, double x){
	double p=0;int i;
	for(i=n-1 ; i>=0 ; i--)
		p = p*x + (i+1)*a[i+1];	
	return p;
}

double horner2(double a[], int n, double x){
	double p=0;int i;
	for(i=n ; i>=0 ; i--)
		p = p*x + (double) a[i] / (i+1);	
	p *= x;
	return p;
}

double horner3(double a[], int n, double x){
	double p=0;int i, predznak;
	predznak = n%2 ? -1 : 1;
	for(i=n ; i>=0 ; i--){
		p = p*x*x + predznak * a[n-i];	
		predznak = -predznak;
	}
	
	return p;
}

double horner4(double a[], int n, double x){
	double p=0;int i;
	for(i=n ; i>=0 ; i--)
		p = p*x + a[n-i]*a[n-i] + n-i;		
	return p;
}

int main(void){
	double a[] = {1.0, 2.0 ,4.0, -2.0, 5.0, 6.0, 7.0, -5.0, 9.0, 3.0};
	double x = 2.7;
	printf("p(%g) = %g\n", x, horner1(a, 9, x));	
	printf("p(%g) = %g\n", x, horner2(a, 9, x));	
	printf("p(%g) = %g\n", x, horner3(a, 9, x));	
	printf("p(%g) = %g\n", x, horner4(a, 9, x));	
	return 0;
}
